// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO20/16AO20_Linux_2.x.x.x_GSC_DN/include/16ao20_utils.h $
// $Rev: 52758 $
// $Date: 2023-04-05 15:03:49 -0500 (Wed, 05 Apr 2023) $

// 16AO20: Utilities: header file

#ifndef	__16AO20_UTILS_H__
#define	__16AO20_UTILS_H__

#include "16ao20_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ao20_close_util			(int fd, int index, int verbose);
int ao20_init_util			(int verbose);
int ao20_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ao20_open_util			(int device, int share, int index, int verbose, int* fd);
int ao20_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);
int	ao20_write_util			(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	ao20_auto_cal_sts		(int fd, int index, int verbose, s32* get);						// AO20_IOCTL_AUTO_CAL_STS
int	ao20_auto_calibrate		(int fd, int index, int verbose);								// AO20_IOCTL_AUTO_CALIBRATE
int	ao20_buffer_clear		(int fd, int index, int verbose);								// AO20_IOCTL_BUFFER_CLEAR
int	ao20_buffer_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_BUFFER_MODE
int	ao20_buffer_over_data	(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_BUFFER_OVER_DATA
int	ao20_buffer_over_frame	(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_BUFFER_OVER_FRAME
int	ao20_buffer_size		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_BUFFER_SIZE
int	ao20_buffer_status		(int fd, int index, int verbose, s32* get);						// AO20_IOCTL_BUFFER_STATUS
int	ao20_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_BURST_ENABLE
int	ao20_burst_ready		(int fd, int index, int verbose, s32* get);						// AO20_IOCTL_BURST_READY
int	ao20_burst_trig_src		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_BURST_TRIG_SRC
int	ao20_burst_trigger		(int fd, int index, int verbose);								// AO20_IOCTL_BURST_TRIGGER
int	ao20_channel_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_CHANNEL_SEL
int	ao20_clock_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_CLOCK_ENABLE
int	ao20_clock_osc_src		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_CLOCK_OSC_SRC
int	ao20_clock_ready		(int fd, int index, int verbose, s32* get);						// AO20_IOCTL_CLOCK_READY
int	ao20_clock_src			(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_CLOCK_SRC
int	ao20_clock_sw			(int fd, int index, int verbose);								// AO20_IOCTL_CLOCK_SW
int	ao20_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_DATA_FORMAT
int	ao20_ext_clk_in_pol		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_EXT_CLK_IN_POL
int	ao20_ext_trig_in_pol	(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_EXT_TRIG_IN_POL
int	ao20_ext_trig_out_pol	(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_EXT_TRIG_OUT_POL
int	ao20_ground_sense		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_GROUND_SENSE
int	ao20_initialize			(int fd, int index, int verbose);								// AO20_IOCTL_INITIALIZE
int	ao20_irq_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_IRQ_SEL
int	ao20_load_ready			(int fd, int index, int verbose, s32* get);						// AO20_IOCTL_LOAD_READY
int	ao20_load_request		(int fd, int index, int verbose);								// AO20_IOCTL_LOAD_REQUEST
int	ao20_nclk				(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_NCLK
int	ao20_nrate				(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_NRATE
int	ao20_output_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_OUTPUT_MODE
int	ao20_query				(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_QUERY
int	ao20_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AO20_IOCTL_REG_MOD
int	ao20_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AO20_IOCTL_REG_READ
int	ao20_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AO20_IOCTL_REG_WRITE
int	ao20_sample_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_SAMPLE_MODE
int	ao20_tx_io_abort		(int fd, int index, int verbose, s32* get);						// AO20_IOCTL_TX_IO_ABORT
int	ao20_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_TX_IO_MODE
int	ao20_tx_io_over_data	(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_TX_IO_OVER_DATA
int	ao20_tx_io_over_frame	(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_TX_IO_OVER_FRAME
int	ao20_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_TX_IO_TIMEOUT
int	ao20_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// AO20_IOCTL_WAIT_CANCEL
int	ao20_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO20_IOCTL_WAIT_EVENT
int	ao20_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// AO20_IOCTL_WAIT_STATUS
int	ao20_xcvr_type			(int fd, int index, int verbose, s32 set, s32* get);			// AO20_IOCTL_XCVR_TYPE

// Auxiliary utility services

int	ao20_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	ao20_fref_compute		(int fd, int index, int verbose, s32* get);
int	ao20_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* osc_src, s32* nclk, s32* nrate, double* rate);
int	ao20_fsamp_ao_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	ao20_fsamp_ao_report_all(int fd, int index, int verbose, s32* fsamp);
int	ao20_id_device			(int fd, int index, int verbose);

int	ao20_count_boards		(int verbose, s32* get);
int	ao20_fsamp_get			(int fd, int title, s32* get);
int	ao20_reg_list			(int fd, int detail);

const gsc_reg_def_t*		ao20_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*		ao20_reg_get_def_index		(int index);
const char*					ao20_reg_get_desc			(u32 reg);
const char*					ao20_reg_get_name			(u32 reg);



#endif
