// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO20/16AO20_Linux_2.x.x.x_GSC_DN/samples/id/perform.c $
// $Rev: 52764 $
// $Date: 2023-04-05 15:10:19 -0500 (Wed, 05 Apr 2023) $

// 16AO20: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Master (30MHz), Alternate (16MHz-32MHz), External, Software\n");
}



//*****************************************************************************
static void _output_modes(void)
{
	gsc_label("Output Modes");
	printf("Simultaneous, Sequential\n");
}



//*****************************************************************************
static void _clocking_modes(void)
{
	gsc_label("Clocking Modes");
	printf("Continuous, Triggered Burst\n");
}



//*****************************************************************************
static void _transceivers(void)
{
	gsc_label("Control Transceivers");
	printf("LVDS, TTL\n");
}



//*****************************************************************************
static int _id_device_for(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) ao20_reg_get_def_id(AO20_GSC_FOR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, ao20_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. ao20_reg_get_def_id, AO20_GSC_FOR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ao20_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_output_modes();
	_clocking_sources();
	_clocking_modes();
	_transceivers();

	for (i = 0; i < AO20_QUERY_LAST; i++)
		errs	+= ao20_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_for(args);
	errs	+= _register_map(args);

	return(errs);
}


