// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO20/16AO20_Linux_2.x.x.x_GSC_DN/samples/sbtest/irq_sel.c $
// $Rev: 52761 $
// $Date: 2023-04-05 15:08:50 -0500 (Wed, 05 Apr 2023) $

// 16AO20: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_INIT_DONE,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_AUTO_CAL_DONE,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_BUF_EMPTY,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_BUF_1Q_FULL,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x300
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_BUF_3Q_FULL,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x400
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_BURST_TRIG_READY,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x500
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_LOAD_READY,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x600
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_IRQ_SEL,
			/* arg		*/	AO20_IRQ_LOAD_READY_END,
			/* reg		*/	AO20_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x700
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= ao20_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= ao20_initialize(fd, -1, 0);
	return(errs);
}




//*****************************************************************************
static int _function_test(int fd)
{
	// These are tested via the wait event service.
	return(0);
}




/******************************************************************************
*
*	Function:	irq_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AO20_IOCTL_IRQ_SEL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("AO20_IOCTL_IRQ_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


