// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO20/16AO20_Linux_2.x.x.x_GSC_DN/utils/util_clock_enable.c $
// $Rev: 43187 $
// $Date: 2018-07-06 16:45:10 -0500 (Fri, 06 Jul 2018) $

// 16AO20: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao20_clock_enable
*
*	Purpose:
*
*		Provide a visual wrapper for the AO20_IOCTL_CLOCK_ENABLE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ao20_clock_enable(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("Clock Enable", index);

	ret		= ao20_ioctl(fd, AO20_IOCTL_CLOCK_ENABLE, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			sprintf(buf, "INVALID: %ld", (long) set);
			break;

		case AO20_CLOCK_ENABLE_NO:

			strcpy(buf, "No, Disable");
			break;

		case AO20_CLOCK_ENABLE_YES:

			strcpy(buf, "Yes, Enable");
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


